/*++

Copyright (c) 2009	Microsoft Corporation

Module Name:
	IsrDpc.h

Abstract:
	Interrupt Handler

Revision History:
	Who 		When		What						
	--------	--------	-----------------------------------------------
	Chen Tian	16-03-09	Wrtitten For NetFPGA2 Card in Microsoft Research Asia
Notes:

--*/

#ifndef _PCIE_INTERRUPT_H_
#define _PCIE_INTERRUPT_H_

#define AFFINITY_MASK(n) ((ULONG_PTR)1 << (n))

NTSTATUS
PCIEInterruptCreate(IN PDEVICE_EXTENSION pDevExt);

BOOLEAN
PCIEEvtInterruptIsr(IN WDFINTERRUPT Interrupt, IN ULONG MessageID);

VOID
PCIEEvtInterruptDpc(IN WDFINTERRUPT Interrupt,IN WDFDEVICE Device);

NTSTATUS
PCIEEvtInterruptEnable(
	IN WDFINTERRUPT		Interrupt,
	IN WDFDEVICE		Device
	);

NTSTATUS
PCIEEvtInterruptDisable(
	IN WDFINTERRUPT		Interrupt,
	IN WDFDEVICE		Device
	);

#endif