/*++

Copyright (c) 2009	Microsoft Corporation

Module Name:
	PCIRequest.h

Abstract:
	Interface with PCI Bus

Revision History:
	Who 		When		What						
	--------	--------	-----------------------------------------------
	Chen Tian	16-03-09	Wrtitten For NetFPGA2 Card in Microsoft Research Asia
Notes:

--*/

#ifndef _PCI_SLOT_INFO
#define _PCI_SLOT_INFO

#include "wdm.h"

NTSTATUS
FPGAWriteRegister(
	IN	PDEVICE_EXTENSION	pDevExt,
	IN	PVOID				pRegister,
	IN	size_t				length
	);

NTSTATUS
FPGAReadRegister(
	IN		PDEVICE_EXTENSION	pDevExt,
	IN		PVOID				pInputBuffer,
	OUT 	PVOID				pOutBuffer
	);

void 
PCIEEvtGetPCIInfo (
	IN	PDEVICE_EXTENSION	pDevExt,
	OUT PPCI_COMMON_CONFIG
	);

void PCIEEvtSetPCIInfo (
	IN	PDEVICE_EXTENSION	pDevExt,
	IN PPCI_COMMON_CONFIG
	);

#endif