/*++

Copyright (c) 2009	Microsoft Corporation

Module Name:
	Nic_req.h

Abstract:
	This module handle NDIS OID ioctls. This module is not required
	if the upper edge is not NDIS.

Revision History:
	Who 		When		What						
	--------	--------	-----------------------------------------------
	Chen Tian	16-03-09	Wrtitten For NetFPGA2 Card in Microsoft Research Asia
Notes:

--*/

#ifndef _NIC_REQ_H
#define _NIC_REQ_H

#include "Device.h"

ULONG
NICHandleQueryOidRequest(
						 IN WDFQUEUE				Queue,
						 IN WDFREQUEST			 	Request,
						 IN PDEVICE_EXTENSION		pDevExt,
						 IN PVOID					pOutputBuffer,
						 IN SIZE_T					OutputBufferSize,
						 WDF_REQUEST_PARAMETERS  	*Params
						 );

VOID
NICHandleSetOidRequest(
	IN WDFQUEUE					Queue,
	IN WDFREQUEST				Request,
	IN PDEVICE_EXTENSION		pDevExt,
	IN PVOID						pInputBuffer,
	IN SIZE_T					InputBufferSize,
	WDF_REQUEST_PARAMETERS	*Params
	);

#endif