/*++

Copyright (c) 2009	Microsoft Corporation

Module Name:
	Public.h

Abstract:
	This module contains the common declarations shared by driver
    	and user applications.

Revision History:
	Who 		When		What						
	--------	--------	-----------------------------------------------
	Chen Tian	16-03-09	Wrtitten For NetFPGA2 Card in Microsoft Research Asia
Notes:

--*/

#ifndef _PUBLIC
#define _PUBLIC

#define BUDDY_DEVICE_NAME      L"\\Device\\NF2HWDevice"
#define SDR_DEVICE_SYMBOL_NAME L"\\DosDevices\\NF2HWDevice"
#define DRIVER_NAME			   L"\\\\.\\NF2HWDevice"

#define NDISWDMLINKNAME_STRING     L"\\DosDevices\\NetFpga2"
#define NDISWDMDEVICE_STRING     L"\\Device\\NetFpga2"
#define NDISWDMDRIVER_NAME	L"\\\\.\\NetFpga2"

#define IOCTL_READ_REG			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x800, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_WRITE_REG			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x801, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_BUDDY_CONNECT 	CTL_CODE(FILE_DEVICE_UNKNOWN, 0x802, METHOD_NEITHER, FILE_ANY_ACCESS)
#define IOCTL_START_MAC	        CTL_CODE(FILE_DEVICE_UNKNOWN, 0x803, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_STOP_MAC  	    CTL_CODE(FILE_DEVICE_UNKNOWN, 0x804, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_GET_PCI_INFO  	CTL_CODE(FILE_DEVICE_UNKNOWN, 0x805, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_SET_PCI_INFO  	CTL_CODE(FILE_DEVICE_UNKNOWN, 0x806, METHOD_BUFFERED, FILE_ANY_ACCESS)

// For mux 
//
// To support ioctls from user-mode:
//

#define LINKNAME_STRING     L"\\DosDevices\\Mux"
#define NTDEVICE_STRING     L"\\Device\\Mux"

#define  MUX_CUSTOM_EVENT      1

#define NOTIFY_SIGNATURE       0xAFCDABAB

#define NETFPGA_IOCTL_GETPACKET      \
        CTL_CODE(FILE_DEVICE_NETWORK, 0x301, METHOD_BUFFERED, FILE_READ_DATA)

#define NETFPGA_IOCTL_SENDPACKET      \
        CTL_CODE(FILE_DEVICE_NETWORK, 0x302, METHOD_BUFFERED, FILE_WRITE_DATA)

/* data structure definition */
typedef struct _INFO_STORAGE
{
	unsigned long       nPort;
	unsigned long       nLen;
	unsigned char       pktbuf[1518];
}INFO_STORAGE,*PINFO_STORAGE;

// new OIDs and data structure for BCube driver

#define OID_GEN_ADD_FORWARD_TABLE	0x00010301 //(set)
#define OID_GEN_DEL_FORWARD_TABLE	0x00010302 //(set)
#define OID_GEN_BCN_ADDRESS			0x00010303 //(set)
#define OID_GEN_GET_MAC_0				0x00010304 //(get)
#define OID_GEN_GET_MAC_1				0x00010305 //(get)
#define OID_GEN_GET_MAC_2				0x00010306 //(get)
#define OID_GEN_GET_MAC_3				0x00010307 //(get)


typedef struct _FORWARD_TABLE {
   unsigned short	nha;	// 9bit
   unsigned char	index;	 // for hardware (0~31)
   unsigned char	mac[6];  // destination mac address
} FORWARD_TABLE, *PFORWARD_TABLE ;
	
#endif