#ifndef _NF2_DOWNLOAD_H
#define _NF2_DOWNLOAD_H

#include "types.h"

size_t bytes_sent;
char *log_file_name;
FILE *log_file;
char *bin_file_name;
FILE *bin_file;
ULONG verbose;
ULONG cpci_reprog;
ULONG prog_addr;
ULONG ignore_dev_info;

#define READ_BUFFER_SIZE 4096
#define SUCCESS 0
#define FAILURE 1

#define CPCI_PROGRAMMING_DATA    0x100
#define CPCI_PROGRAMMING_STATUS  0x104
#define CPCI_PROGRAMMING_CONTROL 0x108
#define CPCI_ERROR               0x010
#define CPCI_ID	                 0x000
#define CPCI_CTRL                0x008


#define START_PROGRAMMING        0x00000001
#define DISABLE_RESET            0x00000100

#define VIRTEX_PROGRAM_CTRL_ADDR        0x0440000
#define VIRTEX_PROGRAM_RAM_BASE_ADDR    0x0480000

#define CPCI_BIN_SIZE            166980

#define VIRTEX_BIN_SIZE_V2_0     1448740
#define VIRTEX_BIN_SIZE_V2_1     2377668



void BeginCodeDownload(char *codefile_name);
void InitGlobals();
void FatalError();
void StripHeader(FILE *code_file);
void DownloadCode(FILE *code_file);
void DownloadVirtexCodeBlock (u_char *code_data, size_t code_data_size);
void DownloadCPCICodeBlock (u_char *code_data, size_t code_data_size);
void ResetDevice(void);
void VerifyDevInfo(void);
void NF2_WR32(ULONG addr, ULONG data);
ULONG NF2_RD32(ULONG addr);
void processArgs (int argc, char **argv );
void usage ();


#endif
