#include <stdio.h>
#include <stdlib.h>
#include "..\..\inc\Public.h"
#include "..\..\inc\nf2.h"
#include "util.h"
#include "..\..\inc\reg_defines.h"

#define MD5_LEN		4

ULONG cpci_version = -1;
ULONG cpci_revision = -1;
ULONG nf2_device_id = -1;
ULONG nf2_revision = -1;
ULONG nf2_cpci_version = -1;
ULONG nf2_cpci_revision = -1;
char nf2_device_str[DEVICE_STR_LEN] = "";

int Dec(char s[])
{ 
	int i,n=0; 

	for(i=0;s[i];i++)
	{ 
		if (s[i]== ' ') 
			break; 
		if( s[i]>= '0'&&s[i]<= '9') 
			n=n*16+s[i]-'0'; 
		else if( s[i]>= 'a' &&s[i]<= 'f') 
			n=n*16+s[i]-'a'+10; 
		else if( s[i]>= 'A'&&s[i]<= 'F') 
			n=n*16+s[i]-'A'+10; 
		else
		{ 
			printf("Input hex data error\n"); 
			exit(1); 
		}
	}
	return n;
}


/*int testReadWrite () {

	HANDLE hDevice;
	ULONG value, oldvalue;
	ULONG address = CPCI_CONTROL_REG;
	char c;

	hDevice = RequestHandler();
	if ( !hDevice)
		return 0;
	if ( !(ReadRegister ( hDevice, address, &value)))
		return 0;

	printf ( "original value is %x\n", value);

	oldvalue = value;
	value = 0xdeadbeef;
	if ( !(WriteRegister ( hDevice, address, &value)))
		return 0;

	if ( !(ReadRegister ( hDevice, address, &value)))
		return 0;

	printf ( "the new value is %x\n", value);

	if ( value != 0xdeadbeef) {
		printf ("write failure\n");
		return 0;
	}

	// write the original data back
	if ( !(WriteRegister ( hDevice, address, &oldvalue)))
		return 0;

	if ( !(ReadRegister ( hDevice, address, &value)))
		return 0;
	if ( value!=oldvalue)
		printf ( "write back original value failed\n");
	else
		printf ("DONE!\n");

	CloseHandle (hDevice);
	scanf ("%c", &c);

	return 1;
}*/

HANDLE RequestHandler () {

	HANDLE hDevice;

	//
	// Request write access to the device.
	// This will fail if the process does not have appropriate privs.
	//
	//hDevice = CreateFile(DRIVER_NAME,
	hDevice = CreateFile(NDISWDMDRIVER_NAME,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,   // security attributes
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,      // flags & attributes
		NULL);  // template file
	if (hDevice == INVALID_HANDLE_VALUE) {
		printf("CreateFile failed! \n");
		return 0;
	}
	else
		return hDevice;
}

bool GetPCIInfo ( HANDLE hDevice, PPCI_COMMON_CONFIG pConfig) {

	DWORD outputsize;

	if ( !(DeviceIoControl (hDevice, IOCTL_GET_PCI_INFO, NULL, 0, pConfig, sizeof(PCI_COMMON_CONFIG), &outputsize, NULL))) {
		printf ("failed to get PCI information\n");
		return false;
	}
	else
		return true;
}

bool SetPCIInfo ( HANDLE hDevice, PPCI_COMMON_CONFIG pConfig) {

	DWORD outputsize;

	if ( !(DeviceIoControl (hDevice, IOCTL_SET_PCI_INFO, pConfig, sizeof(PCI_COMMON_CONFIG), NULL, 0, &outputsize, NULL))) {
		printf ("failed to set PCI information\n");
		return false;
	}
	else
		return true;
}

/**
Help function
Return value:
True: Success
False: Failure
*/
bool ReadRegister ( IN HANDLE hDevice, IN ULONG address, OUT PULONG value) {

	ULONG output;
	DWORD outputsize;
	RegDes reg;

	reg.Address = address;

	if ( !(DeviceIoControl (hDevice, IOCTL_READ_REG, &reg, sizeof(RegDes),&reg, sizeof(RegDes),&outputsize, NULL))) {
		printf ("failed to read\n");
		return false;
	}
	else
		*value = reg.Value;
	return true;
}

/**
Help function
Return value:
True: Success
False: Failure
*/
bool WriteRegister ( IN HANDLE hDevice, IN ULONG address, IN PULONG value) {

	DWORD outputsize;
	RegDes reg;

	reg.Address = address;
	reg.Value = *value;

	if ( !(DeviceIoControl (hDevice, IOCTL_WRITE_REG, &reg, sizeof(RegDes), NULL, 0, &outputsize, NULL))) {
		printf ("failed to write\n");
		return false;
	} 
	else
		return true;
}

void NF2ReadInfo ( IN HANDLE hDevice) {
	int i;
	int md5_good = 1;
	ULONG md5[MD5_LEN];
	ULONG cpci_id;
	ULONG nf2_cpci_id;

	// Read the CPCI version/revision
	ReadRegister (hDevice, CPCI_ID_REG, &cpci_id);
	cpci_version = cpci_id & 0xffffff;
	cpci_revision = cpci_id >> 24;

	// Verify the MD5 checksum of the device ID block
	for  (i = 0; i < MD5_LEN; i++) {
		ReadRegister(hDevice, DEVICE_MD5_1_REG + i * 4, &md5[i]);
	}
	md5_good &= md5[0] == DEVICE_MD5_1_VAL;
	md5_good &= md5[1] == DEVICE_MD5_2_VAL;
	md5_good &= md5[2] == DEVICE_MD5_3_VAL;
	md5_good &= md5[3] == DEVICE_MD5_4_VAL;

	// Process only if the MD5 sum is good
	if (md5_good) {
		// Read the version and revision
		ReadRegister(hDevice, DEVICE_ID_REG, &nf2_device_id);
		ReadRegister(hDevice, DEVICE_REVISION_REG, &nf2_revision);
		ReadRegister(hDevice, DEVICE_CPCI_ID_REG, &nf2_cpci_id);
		nf2_cpci_version = nf2_cpci_id & 0xffffff;
		nf2_cpci_revision = nf2_cpci_id >> 24;

		// Read the version string
		for (i = 0; i < (DEVICE_STR_LEN / 4) - 2; i++)
		{
			ReadRegister(hDevice, DEVICE_STR_REG + i * 4, (PULONG)(nf2_device_str + i * 4));
		}
		nf2_device_str[DEVICE_STR_LEN - 1] = '\0';
	}
}

ULONG DumpRegister ( HANDLE hDevice, ULONG address) {
	ULONG value;
	if ( !ReadRegister ( hDevice, address, &value)) {
		printf ("Cannot read register at 0x%x\n", address);
		exit(0);
	}
	return value;
}

/**
	Help routine to dump all the CPCI registers
*/
void DumpCPCI ( HANDLE hDevice) {

	printf ( "CPCI_ID_REG: 0x%x\n",					DumpRegister ( hDevice, CPCI_ID_REG));
	printf ( "CPCI_BOARD_ID_REG: 0x%x\n",			DumpRegister ( hDevice, CPCI_BOARD_ID_REG));
	printf ( "CPCI_CONTROL_REG: 0x%x\n",			DumpRegister ( hDevice, CPCI_CONTROL_REG));
	printf ( "CPCI_RESET_REG: 0x%x\n",				DumpRegister ( hDevice, CPCI_RESET_REG));
	printf ( "CPCI_ERROR_REG: 0x%x\n",				DumpRegister ( hDevice, CPCI_ERROR_REG));
	printf ( "CPCI_DUMMY_REG: 0x%x\n",				DumpRegister ( hDevice, CPCI_DUMMY_REG));

	printf ( "CPCI_INTERRUPT_MASK_REG: 0x%x\n",		DumpRegister ( hDevice, CPCI_INTERRUPT_MASK_REG));
	printf ( "CPCI_INTERRUPT_STATUS_REG: 0x%x\n",	DumpRegister ( hDevice, CPCI_INTERRUPT_STATUS_REG));

	printf ( "CPCI_CNET_CLK_SEL_REG: 0x%x\n",		DumpRegister ( hDevice, CPCI_CNET_CLK_SEL_REG));

	printf ( "CPCI_REPROG_DATA_REG: 0x%x\n",		DumpRegister ( hDevice, CPCI_REPROG_DATA_REG));
	printf ( "CPCI_REPROG_STATUS_REG: 0x%x\n",		DumpRegister ( hDevice, CPCI_REPROG_STATUS_REG));
	printf ( "CPCI_REPROG_CTRL_REG: 0x%x\n",		DumpRegister ( hDevice, CPCI_REPROG_CTRL_REG));

	printf ( "CPCI_DMA_ADDR_I_REG: 0x%x\n",			DumpRegister ( hDevice, CPCI_DMA_ADDR_I_REG));
	printf ( "CPCI_DMA_ADDR_E_REG: 0x%x\n",			DumpRegister ( hDevice, CPCI_DMA_ADDR_E_REG));
	printf ( "CPCI_DMA_SIZE_I_REG: 0x%x\n",			DumpRegister ( hDevice, CPCI_DMA_SIZE_I_REG));
	printf ( "CPCI_DMA_SIZE_E_REG: 0x%x\n",			DumpRegister ( hDevice, CPCI_DMA_SIZE_E_REG));
	printf ( "CPCI_DMA_CTRL_I_REG: 0x%x\n",			DumpRegister ( hDevice, CPCI_DMA_CTRL_I_REG));
	printf ( "CPCI_DMA_CTRL_E_REG: 0x%x\n",			DumpRegister ( hDevice, CPCI_DMA_CTRL_E_REG));
	printf ( "CPCI_DMA_XFER_TIME_REG: 0x%x\n",		DumpRegister ( hDevice, CPCI_DMA_XFER_TIME_REG));
	printf ( "CPCI_DMA_RETRIES_REG: 0x%x\n",		DumpRegister ( hDevice, CPCI_DMA_RETRIES_REG));

	printf ( "CPCI_CNET_READ_TIME_REG: 0x%x\n",		DumpRegister ( hDevice, CPCI_CNET_READ_TIME_REG));

	printf ( "CPCI_DMA_INGRESS_PKT_CNT_REG: 0x%x\n",DumpRegister ( hDevice, CPCI_DMA_INGRESS_PKT_CNT_REG));
	printf ( "CPCI_DMA_EGRESS_PKT_CNT_REG: 0x%x\n",	DumpRegister ( hDevice, CPCI_DMA_EGRESS_PKT_CNT_REG));
	printf ( "CPCI_CPCI_REG_READ_CNT_REG: 0x%x\n",	DumpRegister ( hDevice, CPCI_CPCI_REG_READ_CNT_REG));
	printf ( "CPCI_CPCI_REG_WRITE_CNT_REG: 0x%x\n",	DumpRegister ( hDevice, CPCI_CPCI_REG_WRITE_CNT_REG));
	printf ( "CPCI_CNET_REG_READ_CNT_REG: 0x%x\n",	DumpRegister ( hDevice, CPCI_CNET_REG_READ_CNT_REG));
	printf ( "CPCI_CNET_REG_WRITE_CNT_REG: 0x%x\n",	DumpRegister ( hDevice, CPCI_CNET_REG_WRITE_CNT_REG));

	printf ( "CPCI_CLOCK_CHECK_N_CLK_REG: 0x%x\n",	DumpRegister ( hDevice, CPCI_CLOCK_CHECK_N_CLK_REG));
	printf ( "CPCI_CLOCK_CHECK_P_MAX_REG: 0x%x\n",	DumpRegister ( hDevice, CPCI_CLOCK_CHECK_P_MAX_REG));
	printf ( "CPCI_CLOCK_CHECK_N_EXP_REG: 0x%x\n",	DumpRegister ( hDevice, CPCI_CLOCK_CHECK_N_EXP_REG));
	printf ( "CPCI_PCI_CLK_COUNTER_REG: 0x%x\n",	DumpRegister ( hDevice, CPCI_PCI_CLK_COUNTER_REG));
	printf ( "CPCI_CPCI_RESET_COUNTER_REG: 0x%x\n",	DumpRegister ( hDevice, CPCI_CPCI_RESET_COUNTER_REG));

	printf ( "CPCI_DMA_XFER_TIME_DEFAULT: 0x%x\n",	DumpRegister ( hDevice, CPCI_DMA_XFER_TIME_DEFAULT));
	printf ( "CPCI_DMA_RETRIES_DEFAULT: 0x%x\n",	DumpRegister ( hDevice, CPCI_DMA_RETRIES_DEFAULT));
	printf ( "CPCI_CNET_READ_TIME_DEFAULT: 0x%x\n",	DumpRegister ( hDevice, CPCI_CNET_READ_TIME_DEFAULT));
	
}

/**
	Help routine to dump several reference router registers
*/
void DumpCNET ( HANDLE hDevice) {

	printf ( "DEVICE_MD5_1_REG: 0x%x\n",				DumpRegister ( hDevice, DEVICE_MD5_1_REG));
	printf ( "DEVICE_MD5_2_REG: 0x%x\n",				DumpRegister ( hDevice, DEVICE_MD5_2_REG));
	printf ( "DEVICE_MD5_3_REG: 0x%x\n",				DumpRegister ( hDevice, DEVICE_MD5_3_REG));
	printf ( "DEVICE_MD5_4_REG: 0x%x\n",				DumpRegister ( hDevice, DEVICE_MD5_4_REG));
	printf ( "DEVICE_ID_REG: 0x%x\n",					DumpRegister ( hDevice, DEVICE_ID_REG));
	printf ( "DEVICE_REVISION_REG: 0x%x\n",				DumpRegister ( hDevice, DEVICE_REVISION_REG));
	printf ( "DEVICE_CPCI_ID_REG: 0x%x\n",				DumpRegister ( hDevice, DEVICE_CPCI_ID_REG));
	printf ( "MAC_GRP_0_CONTROL_REG: 0x%x\n",			DumpRegister ( hDevice, MAC_GRP_0_CONTROL_REG));
	printf ( "ROUTER_OP_LUT_MAC_0_HI_REG: 0x%x\n",		DumpRegister ( hDevice, ROUTER_OP_LUT_MAC_0_HI_REG));
	printf ( "ROUTER_OP_LUT_MAC_0_LO_REG: 0x%x\n",		DumpRegister ( hDevice, ROUTER_OP_LUT_MAC_0_LO_REG));

	printf ( "MDIO_0_CONTROL_REG: 0x%x\n",				DumpRegister ( hDevice, MDIO_0_CONTROL_REG));
	printf ( "MDIO_0_STATUS_REG: 0x%x\n",				DumpRegister ( hDevice, MDIO_0_STATUS_REG));
	printf ( "MDIO_1_CONTROL_REG: 0x%x\n",				DumpRegister ( hDevice, MDIO_1_CONTROL_REG));
	printf ( "MDIO_2_CONTROL_REG: 0x%x\n",				DumpRegister ( hDevice, MDIO_2_CONTROL_REG));
	printf ( "MDIO_3_CONTROL_REG: 0x%x\n",				DumpRegister ( hDevice, MDIO_3_CONTROL_REG));
	
}

/**
	Help routine to dump several reference nic registers
*/
void DumpNICCounters( HANDLE hDevice)
{
  printf("Mac control reg on port 0:             %u\n", DumpRegister ( hDevice, MAC_GRP_0_CONTROL_REG));	
  printf("Num pkts received on port 0:           %u\n", DumpRegister ( hDevice, RX_QUEUE_0_NUM_PKTS_STORED_REG));
  printf("Num pkts dropped (rx queue 0 full):    %u\n", DumpRegister ( hDevice, RX_QUEUE_0_NUM_PKTS_DROPPED_FULL_REG));
  printf("Num pkts dropped (bad fcs q 0):        %u\n", DumpRegister ( hDevice, RX_QUEUE_0_NUM_PKTS_DROPPED_BAD_REG));
  printf("Num bytes received on port 0:          %u\n", DumpRegister ( hDevice, RX_QUEUE_0_NUM_BYTES_PUSHED_REG));
  printf("Num pkts sent from port 0:             %u\n", DumpRegister ( hDevice, TX_QUEUE_0_NUM_PKTS_SENT_REG));
  printf("Num bytes sent from port 0:            %u\n\n", DumpRegister ( hDevice, TX_QUEUE_0_NUM_BYTES_PUSHED_REG));

  printf("Mac control reg on port 1:             %u\n", DumpRegister ( hDevice, MAC_GRP_1_CONTROL_REG));
  printf("Num pkts received on port 1:           %u\n", DumpRegister ( hDevice, RX_QUEUE_1_NUM_PKTS_STORED_REG));
  printf("Num pkts dropped (rx queue 1 full):    %u\n", DumpRegister ( hDevice, RX_QUEUE_1_NUM_PKTS_DROPPED_FULL_REG));
  printf("Num pkts dropped (bad fcs q 1):        %u\n", DumpRegister ( hDevice, RX_QUEUE_1_NUM_PKTS_DROPPED_BAD_REG));
  printf("Num bytes received on port 1:          %u\n", DumpRegister ( hDevice, RX_QUEUE_1_NUM_BYTES_PUSHED_REG));
  printf("Num pkts sent from port 1:             %u\n", DumpRegister ( hDevice, TX_QUEUE_1_NUM_PKTS_SENT_REG));
  printf("Num bytes sent from port 1:            %u\n\n", DumpRegister ( hDevice, TX_QUEUE_1_NUM_BYTES_PUSHED_REG));

  printf("Mac control reg on port 2:             %u\n", DumpRegister ( hDevice, MAC_GRP_2_CONTROL_REG));
  printf("Num pkts received on port 2:           %u\n", DumpRegister ( hDevice, RX_QUEUE_2_NUM_PKTS_STORED_REG));
  printf("Num pkts dropped (rx queue 2 full):    %u\n", DumpRegister ( hDevice, RX_QUEUE_2_NUM_PKTS_DROPPED_FULL_REG));
  printf("Num pkts dropped (bad fcs q 2):        %u\n", DumpRegister ( hDevice, RX_QUEUE_2_NUM_PKTS_DROPPED_BAD_REG));
  printf("Num bytes received on port 2:          %u\n", DumpRegister ( hDevice, RX_QUEUE_2_NUM_BYTES_PUSHED_REG));
  printf("Num pkts sent from port 2:             %u\n", DumpRegister ( hDevice, TX_QUEUE_2_NUM_PKTS_SENT_REG));
  printf("Num bytes sent from port 2:            %u\n\n", DumpRegister ( hDevice, TX_QUEUE_2_NUM_BYTES_PUSHED_REG));

  printf("Mac control reg on port 3:             %u\n", DumpRegister ( hDevice, MAC_GRP_3_CONTROL_REG));
  printf("Num pkts received on port 3:           %u\n", DumpRegister ( hDevice, RX_QUEUE_3_NUM_PKTS_STORED_REG));
  printf("Num pkts dropped (rx queue 3 full):    %u\n", DumpRegister ( hDevice, RX_QUEUE_3_NUM_PKTS_DROPPED_FULL_REG));
  printf("Num pkts dropped (bad fcs q 3):        %u\n", DumpRegister ( hDevice, RX_QUEUE_3_NUM_PKTS_DROPPED_BAD_REG));
  printf("Num bytes received on port 3:          %u\n", DumpRegister ( hDevice, RX_QUEUE_3_NUM_BYTES_PUSHED_REG));
  printf("Num pkts sent from port 3:             %u\n", DumpRegister ( hDevice, TX_QUEUE_3_NUM_PKTS_SENT_REG));
  printf("Num bytes sent from port 3:            %u\n\n", DumpRegister ( hDevice, TX_QUEUE_3_NUM_BYTES_PUSHED_REG));
}  

void HardwareReset ( HANDLE hDevice) {
	/* Reset the CPCI */
	ULONG value = RESET_CPCI;
	WriteRegister ( hDevice, CPCI_REG_RESET, &value);

	/* Reset the CNET */

}