#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include "..\nf2_download\util.h"
#include "..\..\inc\public.h"
#include "..\..\inc\reg_defines.h"
#include "..\nf2_download\getopt.h"

HANDLE	hDevice;
ULONG	regaddr;
ULONG	regvalue;
BOOL    bWrite = 0;

void processArgs (int argc, char **argv ) {

	char c;

	/* set defaults */
	regaddr = 0;
	regvalue = 0;

	opterr = 0;

	while ((c = getopt (argc, argv, "r:w:")) != -1)
		switch (c)
	{
		case 'w':
			regvalue = Dec(optarg);
			bWrite = 1;
			break;
		case 'r':
			regaddr = Dec(optarg);
			break;
		case '?':
			printf ("Unknown option character.\n");
		default:
			exit(1);
	}

}

int main(int argc, char **argv) {

	processArgs(argc, argv);

	//
	// Request write access to the device.
	// This will fail if the process does not have appropriate privs.
	//
	//hDevice = CreateFile(DRIVER_NAME,
	hDevice = RequestHandler();
	if (hDevice == INVALID_HANDLE_VALUE) {
		printf("CreateFile failed! \n");
		return 0;
	}

	if ( bWrite )
	{
		if (!WriteRegister(hDevice, regaddr, &regvalue))
		{
			printf( "Error writing register 0x%x\n", regaddr);
			exit(1);
		}
		printf( "Writing register 0x%x, value 0x%x, %d! \n", regaddr, regvalue, regvalue);


	}
	else
	{
		ULONG val;
		if (!ReadRegister(hDevice, regaddr, &val))
		{
			printf( "Error reading register 0x%x\n", regaddr);
			exit(1);
		}
		printf("reading register 0x%x, value 0x%x, %d! \n", regaddr, val, val);
	}

	CloseHandle (hDevice);
	return 0;
}