// pktools.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "pktools.h"

#include <process.h>
#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "api.h"
#include <winioctl.h>
#include "../../inc/public.h"

// The one and only application object

CWinApp theApp;

using namespace std;

#define MAX_TRY_COUNT 2

HANDLE hConnectEvent; 
OVERLAPPED oConnect;
UCHAR   pktbuff[4000];
INFO_STORAGE info_storage;

int QueueRequest()
{

	printf( "QueueRequest.\n" );

	BOOL rc;
	DWORD err;
	int i;
	DWORD nOutput;

	for (i=0; i<MAX_TRY_COUNT; i++)
	{
		printf( "1.\n" );

		rc = DeviceIoControl(hDevice,
			NETFPGA_IOCTL_GETPACKET,
			NULL,
			0,
			(LPVOID)&info_storage,
			sizeof(INFO_STORAGE),
			&nOutput,
			&oConnect);

		if (rc)
		{
			printf("Read completed immediately.\n");
			return TRUE;
		}

		printf( "2.\n" );
		err = GetLastError();

		if (err == ERROR_IO_PENDING)
		{
			// asynchronous i/o is still in progress 
			printf("Read queued for overlapped I/O.\n");
			return TRUE;
		}

		if ( err == ERROR_INVALID_USER_BUFFER ||
			err == ERROR_NOT_ENOUGH_QUOTA ||
			err == ERROR_NOT_ENOUGH_MEMORY )
		{
			Sleep(50); // Wait around and try later
			continue;
		}
		printf( "3.\n" );
		break;
	}
	printf("ReadFile failed.err %d\n", err);
	return -1;

}


unsigned __stdcall ReadThreadFunc( void* pArguments )
{
	printf( "In read thread...\n" );

	QueueRequest();

	for (;;)
	{
		DWORD rc;
		rc = WaitForSingleObjectEx(hConnectEvent, INFINITE, TRUE );
		if (rc == WAIT_OBJECT_0)
		{
			printf("Recevied a packet\n");
			//break;
		}
		else
		{
			printf("error rc %d\n",rc);
			break;
		}

		int i,j;
		for(i=0;i<10;i++)
		{
			for(j=0;j<10;j++)
			{
				printf("%x-",info_storage.pktbuf[i*10 + j]);
			}
			printf("\n");;

		}

		DWORD dwNumread;

		rc = GetOverlappedResult(
			hDevice,
			&oConnect,
			&dwNumread,
			FALSE
			);
		printf("Read returned %d. %d bytes were read.\n",
			rc, dwNumread);

		QueueRequest();
	}


	return 0;
} 

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: MFC initialization failed\n"));
		nRetCode = 1;

		return nRetCode;
	}

	// TODO: code your application's behavior here.
	HANDLE hThread;
	unsigned threadID;

	hConnectEvent = CreateEvent( 
		NULL,    // default security attribute
		TRUE,    // manual reset event 
		FALSE,    // initial state = unsignaled 
		NULL);   // unnamed event object 

	if (hConnectEvent == NULL) 
	{
		printf("CreateEvent failed with %d.\n", GetLastError()); 
		return 0;
	}

	oConnect.Offset     = 0; 
	oConnect.OffsetHigh = 0;
	oConnect.hEvent = hConnectEvent; 

	// Call a subroutine to create one instance, and wait for 
	// the client to connect. 

	int i = API_Initialize();

	if(i)
		printf("success open\n");
	else
	{
		printf("fail open %d",GetLastError());
		return 1;

	}

	printf( "Creating second thread...\n" );


	// Create the second thread.
	//hThread = (HANDLE)_beginthreadex( NULL, 0, &ReadThreadFunc, NULL, 0, &threadID );


	for(;;)
	{
		UCHAR pktbuf[1000];
		for(int i=0;i<6;i++)
		{
			pktbuf[i] = 0xff;
			pktbuf[i+6] = 0x11;
		}

		for(int i=12;i<100;i++)
		{
			pktbuf[i] = 0x58;
		}

		API_SendPacket(0, 100, pktbuf);
		Sleep(1000);
	}

	// Destroy the thread object.
	CloseHandle( hThread );


	_getch();

	return nRetCode;
}
